## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global forgeurl0 https://github.com/yhirose/cpp-httplib
%undefine __cmake_in_source_build

%bcond_without tests
%bcond_with    online
# Compiled version in shared library.
# Does not have any so-version, therefore not default
%bcond_with compile

%if %{without compile}
%undefine __cmake_in_source_build
%global debug_package %{nil}
%endif

Name:           cpp-httplib
Version:        0.20.1
%forgemeta
Release:        %autorelease

Summary:        A C++11 single-file header-only cross platform HTTP/HTTPS library
License:        MIT
URL:            https://github.com/yhirose/cpp-httplib
VCS:            git:%{forgeurl0}
Source0:        %forgesource

BuildRequires:  redhat-rpm-config
BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  libcurl-devel
BuildRequires:  openssl-devel
BuildRequires:  zlib-devel
BuildRequires:  brotli-devel
%if %{with tests}
BuildRequires:  openssl
BuildRequires:  gtest-devel
%endif

%description
A C++11 single-file header-only cross platform HTTP/HTTPS library.

It's extremely easy to setup. Just include the httplib.h file in your code!

%package devel
Summary:        A C++11 single-file header-only cross platform HTTP/HTTPS library
Recommends:     cmake
Requires:       cmake-filesystem%{?_isa}
Requires:       openssl-devel%{?_isa} zlib-devel%{?_isa} brotli-devel%{?_isa}
%if %{with compile}
Requires:       %{name}%{?_isa} = %{version}-%{release}
%else
Provides:       %{name}-static = %{version}-%{release}
%endif

%description devel
A C++11 single-file header-only cross platform HTTP/HTTPS library.

It's extremely easy to setup. Just include the httplib.h file in your code!

NOTE: This is a multi-threaded 'blocking' HTTP library.
If you are looking for a 'non-blocking' library, this is not the one that you want.

Development files only.

%prep
%forgeautosetup -p1


%build
%cmake \
%if %{with compile}
    -DBUILD_SHARED_LIBS=ON -DHTTPLIB_COMPILE=ON \
%endif
%if %{with tests}
    -DHTTPLIB_TEST=ON \
%endif
#
%cmake_build


%install
%cmake_install
rm -r $RPM_BUILD_ROOT%{_docdir}/httplib
rm -r $RPM_BUILD_ROOT%{_licensedir}/httplib


%check
%if %{with tests}
# multiple threads fails many tests
%if %{with online}
  %ctest --parallel 1
%else
  %ctest --parallel 1 --exclude-regex '_Online$'
%endif
%endif


%if %{with compile}
%files
%license LICENSE
%doc README.md
# TODO: should use so-versioned library here, but upstream
# prefers header-only mode.
%{_libdir}/libhttplib.so.*
%endif

%files devel
%if %{without compile}
%license LICENSE
%doc README.md
%else
%{_libdir}/libhttplib.so
%endif
%{_includedir}/httplib.h
%{_libdir}/cmake/httplib

%changelog
## START: Generated by rpmautospec
* Fri May 09 2025 Orion Poplawski <orion@nwra.com> - 0.20.1-1
- Update to 0.20.1

* Mon Feb 17 2025 Orion Poplawski <orion@nwra.com> - 0.19.0-1
- Update to 0.19.0 (CVE-2025-0825) (rhbz#2343758)

* Thu Jan 16 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.18.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Dec 10 2024 Petr Menšík <pemensik@redhat.com> - 0.18.3-1
- Update to 0.18.3 (rhbz#2227575)

* Sat Nov 09 2024 Orion Poplawski <orion@nwra.com> - 0.18.1-1
- Update to 0.18.1

* Tue Sep 17 2024 Orion Poplawski <orion@nwra.com> - 0.18.0-1
- Update to 0.18.0

* Wed Jul 17 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.13.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.13.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.13.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.13.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Wed Jul 12 2023 Petr Menšík <pemensik@redhat.com> - 0.13.1-1
- Update to 0.13.1 (#2213924)

* Fri Jun 02 2023 Petr Menšík <pemensik@redhat.com> - 0.12.5-2
- Use long options working also on epel9

* Fri Jun 02 2023 Petr Menšík <pemensik@redhat.com> - 0.12.5-1
- Update to 12.0.5

* Wed May 03 2023 Petr Menšík <pemensik@redhat.com> - 0.12.3-1
- Update to 0.12.3 (#2192265)

* Fri Apr 14 2023 Petr Menšík <pemensik@redhat.com> - 0.12.2-2
- Require cmake-filesystem.

* Fri Apr 14 2023 Petr Menšík <pemensik@redhat.com> - 0.12.2-1
- Update to 0.12.2 (#2177353)

* Wed Feb 15 2023 Petr Menšík <pemensik@redhat.com> - 0.12.0-3
- Require dependencies from devel package

* Tue Feb 14 2023 Petr Menšík <pemensik@redhat.com> - 0.12.0-2
- Use ctest supported in 0.12.0

* Mon Feb 13 2023 Petr Menšík <pemensik@redhat.com> - 0.12.0-1
- Update to 0.12.0 (#2168018)

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.11.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Jan 05 2023 Petr Menšík <pemensik@redhat.com> - 0.11.3-4
- Add extra flags to test build

* Thu Jan 05 2023 Petr Menšík <pemensik@redhat.com> - 0.11.3-3
- Do not require clan for test

* Thu Jan 05 2023 Petr Menšík <pemensik@redhat.com> - 0.11.3-2
- Upload sources to new version

* Mon Jan 02 2023 Andrew Potter <agpotter@gmail.com> - 0.11.3-1
- Update to 0.11.3

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Aug 24 2021 Petr Menšík <pemensik@redhat.com> - 0.9.3-1
- Update to 0.9.3

* Sat Aug 21 2021 Petr Menšík <pemensik@redhat.com> - 0.9.2-2
- Enable tests during build, use only offline tests

* Sat Aug 21 2021 Petr Menšík <pemensik@redhat.com> - 0.9.2-1
- Initial package version 0.9.2
## END: Generated by rpmautospec
